// ignore_for_file: public_member_api_docs, sort_constructors_first
// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

part of 'form.dart';

class FormInput extends Equatable {
  final String key;
  final FormInputValidator validator;
  final FormInputMetadata metadata;

  String get name => metadata._name ?? key;

  const FormInput(
    this.key,
    this.validator, {
    // ignore: avoid_redundant_argument_values
    this.metadata = const FormInputMetadata<void>(export: true),
  });

  @override
  bool? get stringify => true;

  @override
  List<Object?> get props => [key, validator, metadata];

  FormInput copyWith({
    String? key,
    FormInputValidator? validator,
    FormInputMetadata? metadata,
  }) {
    return FormInput(
      key ?? this.key,
      validator ?? this.validator,
      metadata: metadata ?? this.metadata,
    );
  }

  FormInput clone() {
    return copyWith(
      key: key,
      validator: validator,
      metadata: metadata,
    );
  }
}
